package org.greenstone.gsdl3.gs3build.metadata;

public abstract class AbstractIdentifierFactory
{
  private String idPrelude;
  private int    idSeqNo;

  public AbstractIdentifierFactory(String idPrelude)
  { this.idPrelude = idPrelude;
    this.idSeqNo   = 1;
  }

  public String getNextIdentifier()
  { int id = this.idSeqNo ++;

    return idPrelude + Integer.toString(id);
  }

  public void noteIdentifier(String identifier)
  { if (!identifier.startsWith(this.idPrelude)) 
      return;
  
    identifier = identifier.substring(this.idPrelude.length());

    int value = Integer.parseInt(identifier);
    if (value >= this.idSeqNo) {
      this.idSeqNo = value + 1;
    }
  }
}
